<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>{{ title }}</title>
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="refresh" content="300" /><!-- <meta http-equiv="refresh" content="5" />  每 content 秒網頁自動更新-->

    <!-- 新 Bootstrap4 核心 CSS 文件 -->
    <link rel="stylesheet" href="https://cdn.bootcss.com/bootstrap/4.1.0/css/bootstrap.min.css">
    <!-- jQuery文件。务必在bootstrap.min.js 之前引入 -->
    <script src="https://cdn.bootcss.com/jquery/3.2.1/jquery.min.js"></script>
    <!-- popper.min.js 用于弹窗、提示、下拉菜单 -->
    <script src="https://cdn.bootcss.com/popper.js/1.12.5/umd/popper.min.js"></script>
    <!-- 最新的 Bootstrap4 核心 JavaScript 文件 -->
    <script src="https://cdn.bootcss.com/bootstrap/4.1.0/js/bootstrap.min.js"></script>
    <!--可用來建立使用者小圖示-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <script language="JavaScript">
        // 指定 秒 刷新網頁一次
        var dtn = '{{tid}}';
        var status = '{{status}}';
        console.log('dtn:' + dtn)

        $(function(){
            $("#dry_output_page").text('乾燥貨櫃出料儲豆槽 DO' + dtn + ' 攝影機畫面   ')
            $('#dry_output_page').attr("href", "/camera_DO" + dtn)
            $("#dry_container_output_title").text('乾燥貨櫃出料儲豆槽 DO' + dtn + ' 操作介面')
            $("#coffee_title_pc").text('DO' + dtn + ' 乾燥出料儲豆槽操作介面');
            $("#coffee_title_phone").text('DO' + dtn + ' 操作介面');
            if (status == 2) {
                $('input').prop('disabled', true);
                $('button').prop('disabled', true);
            } else if ( (status == 0) || (status == 1) ) {
                $('input').prop('disabled', false);
                $('button').prop('disabled', false);   
            }
        });

        WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000)
    </script>

    <script>
        // Rita 制動器運作

        var tank_num = '{{tid}}';

        function outputVacuum() {
            var status = "off";
            var check = $("input[name=output_vacuum_status]:checked");
            //大於0代表有被選中
            if (check.length > 0) {
                status = "on";
                $("#cmn-toggle-32").prop('checked', false);
                if (!confirm("你確定要開啟出料儲豆槽真空吸料機嗎?")) {
                    return false;
                };

            } else {
                $("#cmn-toggle-32").prop('checked', true);
                if (!confirm("你確定要關閉出料儲豆槽真空吸料機嗎?")) {
                    return false;
                };
            };

            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": status };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                    setTimeout("alert('出料儲豆槽真空吸料機_開啟成功!')", 500);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                    setTimeout("alert('出料儲豆槽真空吸料機_關閉成功!')", 500);
                } else {
                    alert(res);
                };
            }, 'text')
        };
        function outputVacuum_ON() {
            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": "on" };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                } else {
                    console.log('res error')
                };
            }, 'text')
        }
        function outputVacuum_OFF() {
            var data = { "tank_num": "DO" + tank_num, "command": "output_vacuum_status", "value": "off" };
            console.log('data:', data)
            $.post('/mqtt/{{tid}}', data, function (res) {
                if (res == 'on') {
                    $("#cmn-toggle-32").prop('checked', true);
                } else if (res == 'off') {
                    $("#cmn-toggle-32").prop('checked', false);
                } else {
                    console.log('res error')
                };
            }, 'text')
        }
    </script>

    <script language="JavaScript">
        function changeUpdate() {
            clearInterval(WebUpdate_set);
            var webupdate_time = $("input[name=webupdate_time]").val()
            console.log('webupdate_time' + webupdate_time)
            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , webupdate_time * 1000);
        }
        // jQuery 更新感測器制動器狀態
        function WebUpdate(dtn) {
            $.get('/loading/DO' + dtn, '', function (res) {
                if (res.output_vacuum == 0) {
                    $("#output_vacuum_status").css("background-color", "#C0C0C0")
                } else if (res.output_vacuum == 1) {
                    $("#output_vacuum_status").css("background-color", "forestgreen")
                } else { $("#output_vacuum_status").css("background-color", "crimson") }
                $("#UltraSonic_t_status").text(res.output_UltraSonic);
            }, 'json');
        }
    </script>
</head>

<body>
    <div id="wrapper">
        <div id="coffee_header">
            <!-- 匯入共同使用的 header.html 內容 -->
            {% include 'header.html' %}
        </div>

        <h4>制動器</h4>    
        <table border="1" class="table-all" cellpadding="3" style="text-align: center;">
            <tr>
                <td style="color:red;">Valve</td>
                <td>真空吸料機</td>
            </tr>
            <tr>
                <td>
                    <span style="color:#C0C0C0;">off</span>
                    <span style="color:#008CBA;">on</span>
                </td>
                <td>
                    <div class="switch_div">
                        <div class="switch">
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round" id="cmn-toggle-31">
                        </div>
                        <div class="switch text-center">
                            {% if output_vacuum == 1 %}
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round-flat" id="cmn-toggle-32" checked
                                name="output_vacuum_status" value="ON" onclick="outputVacuum()">
                            {% else %}
                            <input type="checkbox" class="cmn-toggle cmn-toggle-round-flat" id="cmn-toggle-32"
                                name="output_vacuum_status" value="OFF" onclick="outputVacuum()">
                            {% endif %}
                            <label class="label_ActuatorStatus" for="cmn-toggle-32"></label>
                        </div>
                        <div class="switch">
                            <input type="checkbox" class="cmn-toggle cmn-toggle-yes-no" id="cmn-toggle-32">
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td><span style="color:#008CBA;"><b>ON</b></span></td>
                <td><input type="button" class="input-button-on" value="ON" onclick="outputVacuum_ON()"></td>
            </tr>
            <tr>
                <td><span style="color:#C0C0C0;"><b>OFF</b></span></td>
                <td><input type="button" class="input-button-off" value="OFF" onclick="outputVacuum_OFF()"></td>
            </tr>
        </table>

        <br>

        <h4>感測器</h4>
        <table border="1" class="table-all" cellpadding="3">
            <tr>
                <td>[出料儲豆槽] 生豆高度：<span id="UltraSonic_t_status">{{output_UltraSonic.UltraSonic}}</span> 公分</td>
            </tr>
        </table>

        <br>

        <h4>排程設計</h4>
        <table border="1" class="table-all" cellpadding="3">
            <tr>
                <td>入料</td>
                <td>循環測試</td>
            </tr>
            <tr>
                <td>
                    指定桶內生豆高度
                    <input type="text" class="input-text" name="testing_BeanIn_Height" value="0">公分<br>
                    吸料時間
                    <input type="text" class="input-text" name="testing_in_vacuum_in" value="5">秒<br>
                    放料時間
                    <input type="text" class="input-text" name="testing_in_vacuum_out" value="10">秒<br>
                    循環次數
                    <input type="text" class="input-text" name="testing_in_vacuum_loop" value="4">次<br>
                </td>
                <td>
                    ON (開) 
                    <input type="text" class="input-text" name="Testing_starttime" value="5">秒<br>
                    OFF (關) 
                    <input type="text" class="input-text" name="Testing_endtime" value="10">秒<br>
                    循環
                    <input type="text" class="input-text" name="Testing_loop" value="4">次
                </td>
            </tr>
            <tr>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="BeanInput()">入料測試</button>
                    <script>
                        var BeanIn_Process = 0;
                        var BeanIn_interval;
                        function BeanInput() {
                            clearInterval(WebUpdate_set);
                            var testing_BeanIn_Height = $("input[name=testing_BeanIn_Height]").val();
                            var testing_in_vacuum_in = $("input[name=testing_in_vacuum_in]").val();
                            var testing_in_vacuum_out = $("input[name=testing_in_vacuum_out]").val();
                            var testing_in_vacuum_loop = $("input[name=testing_in_vacuum_loop]").val();

                            if (testing_BeanIn_Height != 0) {
                                console.log('以指定高度入豆')
                                var BeanIn_interval = setInterval(BeanInHeight, 5000);

                                function BeanInHeight(){
                                    if (BeanIn_Process == 1) {
                                        return;
                                    }

                                    BeanIn_Process == 1;
                                    $.ajax({
                                        async:false,
                                        type:"GET",
                                        url:"/dry_UltraSonic_" + tank_num,
                                        dataType:"json",
                                        success:function(response){
                                            var present_Bean_height = response.UltraSonic
                                            console.log('目前生豆高度: ' + present_Bean_height)

                                            if ( parseInt(present_Bean_height) < parseInt(testing_BeanIn_Height) ) {
                                                outputVacuum_ON()
                                                console.log('outputVacuum_ON')
                                                
                                                var time = new Date();
                                                while ((new Date() - time) < testing_in_vacuum_in * 1000) { };

                                                outputVacuum_OFF()
                                                console.log('outputVacuum_OFF')

                                                var time = new Date();
                                                while ((new Date() - time) < testing_in_vacuum_out * 1000) { };
                                            } else {
                                                clearInterval(BeanIn_interval)
                                                console.log('生豆已達指定高度！')
                                            }
                                            BeanIn_Process == 0;
                                        },
                                        error:function(thrownError){
                                            console.log('Error: ' + thrownError)
                                            BeanIn_Process = 0;
                                        }
                                    })
                                };

                            } else if (testing_BeanIn_Height == 0) {
                                console.log('以循環次數入豆')

                                for (step = 1; step <= testing_in_vacuum_loop; step++) {
                                    console.log('-- 循環第 ' + step + ' 次 --');

                                    outputVacuum_ON()
                                    console.log('outputVacuum_ON')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_in_vacuum_in * 1000) { };

                                    outputVacuum_OFF()
                                    console.log('outputVacuum_OFF')

                                    var time = new Date();
                                    while ((new Date() - time) < testing_in_vacuum_out * 1000) { };
                                }

                                console.log('循環入豆結束')
                            }
                            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000);
                        }
                    </script>
                </td>
                <td>
                    <button type="submit" class="btn btn-primary" onclick="tankVacuumTest()">真空吸料機測試(秒)</button><br>
                    <script>
                        function tankVacuumTest() {
                            clearInterval(WebUpdate_set);
                            var Testing_starttime = $("input[name=Testing_starttime]").val();
                            var Testing_endtime = $("input[name=Testing_endtime]").val();
                            var Testing_loop = $("input[name=Testing_loop]").val();
                            alert('測試間隔' + Testing_starttime + ':' + Testing_endtime + ' 次數' + Testing_loop)
                            var step;

                            for (step = 1; step <= Testing_loop; step++) {
                                console.log('循環第 ' + step + ' 次');

                                outputVacuum_ON()
                                console.log('outputVacuum_ON')

                                var time = new Date();
                                while ((new Date() - time) < Testing_starttime * 1000) { }

                                outputVacuum_OFF()
                                console.log('outputVacuum_OFF')

                                var time = new Date();
                                while ((new Date() - time) < Testing_endtime * 1000) { }
                            }
                            WebUpdate_set = setInterval(function(){WebUpdate(dtn)} , 10 * 1000);
                        }
                    </script>
                </td>
            </tr>
        </table>

        <div id="coffee_footer">
            <!-- 匯入共同使用的 footer.html 內容 -->
            {% include 'footer.html' %}
        </div>
    </div>

</body>

</html>